
#include "set_slm.h"
//#include "slm_manual_keys.h"
#include "slm_driver.h"
#include <stdio.h>
#include <unistd.h>
#include <math.h>
#include <string.h>
//#include <curses.h>
#include <g++-3/iostream.h>
#include <stdlib.h>

main(int argc,char ** argv){

// set default values
float xoff=0;
float focal_length=2e-3;
float wavelength=37.5e-6;
float slm_height=1.76e-3;
float distortion_factor=1.1;
float msr=0.5;
float px,py;
int frame_rate=60;  


//float factor_xoff=100;
//float factor_focal_length=0.1;
//float factor_wavelength=1;

int index=1;

//int quit=FALSE;
//int update_slm=FALSE;
//int first_run=TRUE;
//char keypress;
//char kp2;
//char inptvalue[12];
float pixel_size;

int tmp;

float wavelength_p, focal_length_p, xoff_p;
cout<<"All measurements in metres\n";
	if(argc==1){
		cout<<"Need some arguments!"<<endl<<endl;
		cout<<"-x    -xoff            : x offset (in metres)      default "<<xoff<<endl;
		cout<<"-f    -focal_length    : focal length (in metres)  default "<<focal_length<<endl;
		cout<<"-l    -wavelength      : line spacing (in metres)  default "<<wavelength<<endl;
		cout<<"-r    -repetition_rate : repetition rate (in Hz)   default "<<frame_rate<<endl;
		cout<<"-s    -slm_height      : slm height (in metres)    default "<<slm_height<<endl;
		cout<<"-d    -distortion      : distortion factor         default "<<distortion_factor<<endl;
		exit(3);
		}
	while(index<argc){
		if(sc(argv[index],"-x")||sc(argv[index],"-xoff")){
			sscanf(argv[++index],"%f",&xoff);
			}

		if(sc(argv[index],"-f")||sc(argv[index],"-focal_length")){
			sscanf(argv[++index],"%f",&focal_length);
			}

		if(sc(argv[index],"-l")||sc(argv[index],"-wavelength")){
			sscanf(argv[++index],"%f",&wavelength);
			}

		if(sc(argv[index],"-r")||sc(argv[index],"-repetition_rate")){
			sscanf(argv[++index],"%d",&frame_rate);
			}

		if(sc(argv[index],"-s")||sc(argv[index],"-slm_height")){
			sscanf(argv[++index],"%f",&slm_height);
			}

		if(sc(argv[index],"-d")||sc(argv[index],"-distortion")){
			sscanf(argv[++index],"%f",&distortion_factor);
			}
		index++;
		}
	
	cout<<"Setting SLM arc attributes:\n"<<flush;
	SLM_reset();
	SLM_repeat(25000);

	// now work out the conversion factors from real world units into SLM pixels
        py=slm_height/256; //in metres
        px=py/distortion_factor;      

	cout<<"Wavelength:            "<<wavelength*1e6<<" microns"<<endl;
	cout<<"Mean focal length:     "<<focal_length*1e6<<" microns"<<endl;
	cout<<"x offset:              "<<xoff*1e6<<" microns"<<endl<<endl;
	cout<<"SLM image height:      "<<slm_height*1e6<<" microns"<<endl;
	cout<<"Distortion factor:     "<<distortion_factor<<endl;
	cout<<"Frame repetition rate: "<<frame_rate<<endl;

	// note that the coordinates are transposed here to match the
	// physical layout of the slm as of june 2001 matt
	// the logical slm X direction corresponds to vertical
	// on the slm with +ve X pointing down
	// the logical Y corresponds to horizontal and is the squished aspect
	// postive Ys correspond to movement in the right hand direction
	// as determined by the camera
	cout<<"Getting SLM status- will segfault if perms are incorrect"<<endl;;
	SLM_print_status();
	cout<<"Calling SLM_upload"<<endl;;
	SLM_upload_arcs(focal_length,xoff,py,px,wavelength,msr,frame_rate);  
 }

 
// Internally the compressed direction is called X and the uncompressed direction is called
// Y.  This works lovely BUT as of the physical set up of june 2001 the horizontal (distorted)
// direction is Y and the vertical (undistorted) direction is X
 
void SLM_upload_arcs(float xoff,float yoff,float px, float py,float wavelength,float msr,int frame_rate){
 
int x,y;
float xc,yc,yc2;
unsigned char frame[8192];
float dist_psf[65536];
char arcs[65536];
short frl[3*2];
FILE *t;
int ap,cp,bit; //ap- arc pointer, cp- compressed (frame) pointer, bit- bit number
 
//cout<<"X offset="<<xoff<<"Y offset ="<<yoff<<" px="<<px<<"py="<<py<<"\n";
// calulated the distance cone to the focal spot for each pixel
// x and y are the logical coords to the arrays, xc and yc are the distances from focus to pixel at (x,y)
//cout<<"px "<<px<<" py "<<py<<"\n";
        for(y=0;y<256;y++){
                yc=((float)y-127.5)*py+yoff;
                yc2=yc*yc;// compiler should remove extra variable, leave for clarity
                for(x=0;x<256;x++){
                        xc=((float)x-127.5)*px+xoff;
                        dist_psf[x+(y*256)]=sqrt((xc*xc)+yc2);
                        }
                }
// should go straight to frame but allow this for clarity
        for(ap=0;ap<65536;ap++){
                        arcs[ap]=(char)(fmod(dist_psf[ap],wavelength) >= (wavelength*msr));
                        }
 
// encode or compress the slm image
        for(ap=0,cp=0;cp<8192;cp++){
                frame[cp]=0;
                for(bit=1;bit<256;bit*=2,ap++){
                        if(arcs[ap])frame[cp]|=bit;
                        //cout<<"b "<<bit<<" ap "<<ap<<"\n";
                        }
                }
	/*
        t=fopen("dist_psf.dat","w");
	if(t<0){
		cout<<"Can't open file for writing- \n";
		exit(1);
		}
        fwrite((void *)dist_psf,sizeof(float),65536,t);
        fclose(t);
 
        t=fopen("arcs.dat","w");
	if(t<0){
		cout<<"Can't open file for writing- \n";
		exit(1);
		}
        fwrite((void *)arcs,sizeof(char),65536,t);
        fclose(t);
 
        t=fopen("coded.dat","w");
	if(t<0){
		cout<<"Can't open file for writing- \n";
		exit(1);
		}
        fwrite((void *)frame,sizeof(char),8192,t);
        fclose(t);
	*/ 
//      cout<<"Uploading to frame "<<1<<"\n";
// upload the data
        SLM_upload_frame(1,frame);
// halt the timer (why?)
        SLM_timer('H');
//      cout<<"Setting FRL\n";
// set the FRL to +ve frame 1, -ve frame 1
        frl[0]=1;frl[1]=0;frl[2]=1;
        frl[3]=1;frl[4]=0x8000;frl[5]=1;
// upload it
        SLM_upload_FRL(2,frl);
// set the rep rate
        SLM_timer_rate((short)frame_rate);
// set the timer to go
        SLM_timer('G');
        }
                                                                                    
/*
void SLM_upload_arcs(float xoff_p, float y_offset_p, float sep_p, float y_distort_sq, int frame_rate)
{
int x,y,l,b;
unsigned char fr[8192];
int frame[8192];
float cone[65536];
int arcs[65536];
short frl[3*2];

	for(x=0;x<256;x++){
		for(y=0;y<256;y++){
			cone[x+(y*256)]=sqrt((y_distort_sq*(y_offset_p-y)*(y_offset_p-y))+((xoff_p-x)*(x_offset_p-x)));
			}
		}
	for(x=0;x<256;x++){
		for(y=0;y<256;y++){
			arcs[x+(y*256)]=(fmod(cone[y+(x*256)],sep_p) >= (sep_p/2));
			}
		}
	for(l=0;l<8192;l++){
		frame[l]=0;
		}

	for(l=0;l<8192;l++){
		for(b=0;b<8;b++){
			frame[l]=frame[l] | (int)(pow(2,b)*(arcs[(l*8)+b]!=0));
			fr[l]=(uchar)frame[l];
			}
		}

//	cout<<"Uploading to frame "<<1<<"\n";
	SLM_upload_frame(1,fr);
	SLM_timer('H');
//	cout<<"Setting FRL\n";
	frl[0]=1;frl[1]=0;frl[2]=1;
	frl[3]=1;frl[4]=0x8000;frl[5]=1;
	SLM_upload_FRL(2,frl);
	SLM_timer_rate((short)frame_rate);
	SLM_timer('G');
	}
*/

BOOL	sc(char *con,char *var){
	if(strcmp(con,var)==0){
		return TRUE;
		}
	return FALSE;
	}

