#include "slm_set.h"
//#include "slm_manual_keys.h"
#include "slm_driver.h"
#include <stdio.h>
#include <unistd.h>
#include <math.h>
//#include <curses.h>
#include <g++/iostream.h>
#include <stdlib.h>

main(int argc,char ** argv){

// set default values

float x_offset=0;
float focal_length=2;
float line_spacing=37.5;
float slm_size=1.6;
float distortion_factor=1.2;
int frame_rate=60;

//float factor_x_offset=100;
//float factor_focal_length=0.1;
//float factor_line_spacing=1;

int index=1;

//int quit=FALSE;
//int update_slm=FALSE;
//int first_run=TRUE;
//char keypress;
//char kp2;
//char inptvalue[12];
float pixel_size;

int tmp;

float line_spacing_p, focal_length_p, x_offset_p;

	if(argc==1){
		cout<<"Need some arguments!"<<endl<<endl;
		cout<<"-x    -x_offset        : x offset (in microns)     default 0"<<endl;
		cout<<"-f    -focal_length    : focal length (in mm)      default 2"<<endl;
		cout<<"-l    -line_spacing    : line spacing (in microns) default 37.5"<<endl;
		cout<<"-r    -repetition_rate : repetition rate (in Hz)   default 60"<<endl;
		cout<<"-s    -slm_size        : slm size (in mm)          default 1.6"<<endl;
		cout<<"-d    -distortion      : distortion factor         default 1.2"<<endl;
		exit(3);
		}
	while(index<argc){
		if(sc(argv[index],"-x")||sc(argv[index],"-x_offset")){
			sscanf(argv[++index],"%f",&x_offset);
			}

		if(sc(argv[index],"-f")||sc(argv[index],"-focal_length")){
			sscanf(argv[++index],"%f",&focal_length);
			}

		if(sc(argv[index],"-l")||sc(argv[index],"-line_spacing")){
			sscanf(argv[++index],"%f",&line_spacing);
			}

		if(sc(argv[index],"-r")||sc(argv[index],"-repetition_rate")){
			sscanf(argv[++index],"%f",&frame_rate);
			}

		if(sc(argv[index],"-s")||sc(argv[index],"-slm_size")){
			sscanf(argv[++index],"%f",&slm_size);
			}

		if(sc(argv[index],"-d")||sc(argv[index],"-distortion")){
			sscanf(argv[++index],"%f",&distortion_factor);
			}
		index++;
		}
	
	cout<<"Setting SLM arc attributes:\n"<<flush;
	SLM_reset();
	SLM_repeat(25000);

	// now work out the conversion factors from real world units into SLM pixels

	pixel_size=(slm_size*1000)/256; //in microns
	x_offset_p=128-(x_offset/pixel_size);
	focal_length_p=(((slm_size/2)-focal_length)*1000)/pixel_size;
	line_spacing_p=line_spacing/pixel_size;

	cout<<"Line spacing:      "<<line_spacing<<" microns"<<endl;
	cout<<"Mean focal length: "<<focal_length<<" mm"<<endl;
	cout<<"x offset:          "<<x_offset<<" microns"<<endl<<endl;
	cout<<"SLM image size:    "<<slm_size<<" mm"<<endl;
	cout<<"Distortion factor: "<<distortion_factor<<endl;
	cout<<"Frame repetition rate: "<<frame_rate<<endl;

	SLM_upload_arcs(x_offset_p, focal_length_p, line_spacing_p, distortion_factor, frame_rate);
	}

void SLM_upload_arcs(float x_offset_p, float y_offset_p, float sep_p, float y_distort_sq, int frame_rate)
{
int x,y,l,b;
unsigned char fr[8192];
int frame[8192];
float cone[65536];
int arcs[65536];
short frl[3*2];

	for(x=0;x<256;x++){
		for(y=0;y<256;y++){
			cone[x+(y*256)]=sqrt((y_distort_sq*(y_offset_p-y)*(y_offset_p-y))+((x_offset_p-x)*(x_offset_p-x)));
			}
		}
	for(x=0;x<256;x++){
		for(y=0;y<256;y++){
			arcs[x+(y*256)]=(fmod(cone[y+(x*256)],sep_p) >= (sep_p/2));
			}
		}
	for(l=0;l<8192;l++){
		frame[l]=0;
		}

	for(l=0;l<8192;l++){
		for(b=0;b<8;b++){
			frame[l]=frame[l] | (int)(pow(2,b)*(arcs[(l*8)+b]!=0));
			fr[l]=(uchar)frame[l];
			}
		}

//	cout<<"Uploading to frame "<<1<<"\n";
	SLM_upload_frame(1,fr);
	SLM_timer('H');
//	cout<<"Setting FRL\n";
	frl[0]=1;frl[1]=0;frl[2]=1;
	frl[3]=1;frl[4]=0x8000;frl[5]=1;
	SLM_upload_FRL(2,frl);
	SLM_timer_rate((short)frame_rate);
	SLM_timer('G');
	}

BOOL	sc(char *con,char *var){
	if(strcmp(con,var)==0){
		return TRUE;
		}
	return FALSE;
	}

