// slm_driver matt clark 2000
// after Carl Paterson IC
// after Copyright (c) 1996 by Displaytech, Inc.  2200 Central Ave.  Boulder, CO 


// NOTE there is a compiler bug in gcc 2.9.xx
// the use of ++ in a function argument list is prohibited because of this error

#include "slm_driver.h"
#include<stdio.h>
void SLM_refresh(void);
void SLM_refresh(void){
	SLM_write('S',SLM_STAT_SYS);
	}

void SLM_print_status(void){
SLM_slim_status_s slim;
	SLM_get_slim_status(&slim);

	if(slim.slm1==TRUE)
		cout<<"SLM 1 is present     ";
	else
		cout<<"SLM 1 is absent      ";
	if(slim.slm2==TRUE)
		cout<<"SLM 2 is present\n";
	else
		cout<<"SLM 2 is absent\n";
	

	if(slim.prk1==TRUE)
		cout<<"SLM 1 is parked      ";
	else
		cout<<"SLM 1 is running     ";
	if(slim.slm2==TRUE)
		cout<<"SLM 2 is parked\n";
	else
		cout<<"SLM 2 is running\n";

	if(slim.sysprk==TRUE)
		cout<<"System is parked     ";
	else
		cout<<"System is running    ";
	if(slim.status==SLM_GOOD)
		cout<<"SLiM is ok\n";
	else
		cout<<"SLiM is bad\n";

	if(slim.cmd==SLM_GOOD)
		cout<<"Command is good      ";
	else
		cout<<"Command is bad       ";
	if(slim.param==SLM_GOOD)
		cout<<"Parameter is good\n";
	else
		cout<<"Parameter is bad\n";
	
	if(slim.frlptr==SLM_GOOD)
		cout<<"Frame ptr is good    ";
	else
		cout<<"Frame ptr is bad     ";
	if(slim.frlpage==SLM_GOOD)
		cout<<"Frame page is good\n";
	else
		cout<<"Frame page is bad\n";
	}




void SLM_get_slim_status(SLM_slim_status_s *slim){
int	i;
	for(i=0;i<SLM_NUM_REGS;i++){
		SLM_write('S',(short)i);
		slim->regs[i]=inb(LPT_STAT);
		//cout<<(int)slim->regs[i]<<":";
		}
	//cout<<endl;
	SLM_refresh();
// fill in the BOOLs
	if(slim->regs[SLM_STAT_SYS]&SLM_STATUS_SYS_FAULT)
		slim->status=SLM_BAD;
	else
		slim->status=SLM_GOOD;
	if(slim->regs[SLM_STAT_SYS]&SLM_STATUS_SYS_PRK)
		slim->sysprk=TRUE;
	else
		slim->sysprk=FALSE;

	if(slim->regs[SLM_STAT_CMD]&SLM_STATUS_CMD_BAD)
		slim->cmd=SLM_BAD;
	else
		slim->cmd=SLM_GOOD;
	if(slim->regs[SLM_STAT_CMD]&SLM_STATUS_PARAM_BAD)
		slim->param=SLM_BAD;
	else
		slim->param=SLM_GOOD;
	
	if(slim->regs[SLM_STAT_FRL]&SLM_STATUS_FRL_BAD_PTR)
		slim->frlptr=SLM_BAD;
	else
		slim->frlptr=SLM_GOOD;
	if(slim->regs[SLM_STAT_FRL]&SLM_STATUS_FRL_BAD_PAGE)
		slim->frlpage=SLM_BAD;
	else
		slim->frlpage=SLM_GOOD;

	if(slim->regs[SLM_STAT_SLM]&SLM_STATUS_SLM1)
		slim->slm1=TRUE;
	else
		slim->slm1=FALSE;
	if(slim->regs[SLM_STAT_SLM]&SLM_STATUS_SLM2)
		slim->slm2=TRUE;
	else
		slim->slm2=FALSE;
	
	if(slim->regs[SLM_STAT_PRK]&SLM_STATUS_PRK1)
		slim->prk1=TRUE;
	else
		slim->prk1=FALSE;
	if(slim->regs[SLM_STAT_PRK]&SLM_STATUS_PRK2)
		slim->prk2=TRUE;
	else
		slim->prk2=FALSE;
	
	if(slim->regs[SLM_STAT_WIN]&SLM_STATUS_SLM1_WIN_BAD)
		slim->win1=SLM_BAD;
	else
		slim->win1=SLM_GOOD;
	if(slim->regs[SLM_STAT_WIN]&SLM_STATUS_SLM2_WIN_BAD)
		slim->win2=SLM_BAD;
	else
		slim->win2=SLM_GOOD;
	
	slim->coprsts=0;
		if(slim->regs[SLM_STAT_COP]&0x08)slim->coprsts += 4;
		if(slim->regs[SLM_STAT_COP]&0x10)slim->coprsts += 2;
		if(slim->regs[SLM_STAT_COP]&0x20)slim->coprsts += 1;
 
	// CLK Status Register
	slim->clkrsts=0;
		if(slim->regs[SLM_STAT_CLK]&0x08)slim->clkrsts += 4;
		if(slim->regs[SLM_STAT_CLK]&0x10)slim->clkrsts += 2;
		if(slim->regs[SLM_STAT_CLK]&0x20)slim->clkrsts += 1;   		

	}








SLM_error SLM_upload_frame(int frame, uchar *data) {
int	row, index,err,N=0,i=0;
	for(index=0,row=0;row<SLM_ROWS_PER_IMAGE;row++){
	//cout<<"Param 0"<<(short)(frame*SLM_ROWS_PER_IMAGE+row)<<endl;
	SLM_write('U',(short)(frame*SLM_ROWS_PER_IMAGE+row),(short)0);	
		for(i=0;i<SLM_ROW_SIZE-2;i+=6){
// because of a compiler bug in gcc 2.91 the use of ++ in an argument list is prohibited
// (the compiler gets the arguments the wrong way around !)
//		err=SLM_write('V',data[index++],data[index++],data[index++],data[index++],data[index++],data[index++]);
		err=SLM_write('V',data[index+0],data[index+1],data[index+2],data[index+3],data[index+4],data[index+5]);
		index+=6;
		if(err!=SLM_OK){
			cout<<"ERROR:SLM_upload_frame index="<<index;
			if(err==SLM_CMD_INVD)cout<<" cmd error"; 
			if(err==SLM_PRM_INVD)cout<<" prm error"; 
			cout<<endl;
			}
		}
		// We have 2 more bytes to send.
		err=SLM_write('V',data[index+0],data[index+1]);index+=2;
		if(err!=SLM_OK){
			cout<<"ERROR:SLM_upload_frame index="<<index;
			if(err==SLM_CMD_INVD)cout<<" cmd error"; 
			if(err==SLM_PRM_INVD)cout<<" prm error"; 
			cout<<endl;
			}
		}
	return SLM_OK;
	}

SLM_error SLM_upload_FRL(int count, short *data) {
int	i,j=0;
//send a 'W' and 3 words (check order later)
	i=0;
// gcc bug	SLM_write('O','W',data[i++],data[i++],data[i++]);
	//cout<<"frame "<<data[i]<<" fcw "<<data[i+1]<<" repeat "<<data[i+2]<<endl;
	SLM_write('O','W',data[i+0],data[i+1],data[i+2]);i+=3;
// send an 'A' with the data now.............
	for(;i < (count*3);){
		// use the complex form of write to over write the count with 'A'
// gcc bug		if(SLM_write('O','A',data[i++],data[i++],data[i++])!=SLM_OK)
	//cout<<"frame "<<data[i]<<" fcw "<<data[i+1]<<" repeat "<<data[i+2]<<endl;
		if(SLM_write('O','A',data[i+0],data[i+1],data[i+2])!=SLM_OK)
			cout<<"ERROR:frl append\n";	
		i+=3;
		}
	return SLM_OK;
	}
// a service function, must not use 'SLM_write' as it is called by SLM_issue_cmd
SLM_status SLM_get_status(void){
SLM_status status;
	// check command status.
	SLM_write_slm_parport(SLM_REG1_SEL,1);
	SLM_write_slm_parport(SLM_REG3_SEL,SLM_STAT_CMD);
	SLM_write_slm_parport(SLM_REG0_SEL,'S');
	SLM_send_dummy();
	// Store the command status register's value.
	status = (int)inb(SLM_LPT_STAT);
	// Restore front panel LEDs to system status register state.
	SLM_write_slm_parport(SLM_REG1_SEL,1);
	SLM_write_slm_parport(SLM_REG3_SEL,SLM_STAT_SYS);
	SLM_write_slm_parport(SLM_REG0_SEL,'S');
	SLM_send_dummy();
	if(status&SLM_CMD_DONE)return SLM_OK; 
	if(status&SLM_CMD_INVD)return SLM_CMD_INVD; 
	if(status&SLM_PRM_INVD)return SLM_PRM_INVD; 
	return SLM_TIMEOUT; 
	}  

// valid commands here are 'H' 'G' 'S' (halt/go/step)
SLM_error SLM_timer(uchar cmd){
	// the extra parameters (zeros) appear meaningless but are
	// written in the case of the original example code--matt 2000
	// they DO appear to be necessary --matt 2000
	return SLM_write((uchar)'T',cmd,(short)0,(short)0,(short)0);
	}

SLM_error SLM_timer_rate(short rate){
short interval;
	interval=SLM_MCU_TIMER_RATE/rate;
	return SLM_write((uchar)'T',(uchar)'R',interval,(short)0,(short)0);
	}
SLM_error SLM_repeat(short one){
	return SLM_write((uchar)'F',one);
	}
// for fidicule, apron and mask I don't know what parameters to send,
// there is no example code for this, just for the commands
SLM_error SLM_fidicule(short one,short two){
	return SLM_write((uchar)'D',one,two);
	}

SLM_error SLM_apron(short one,short two){
	return SLM_write((uchar)'A',one,two);
	}

SLM_error SLM_mask(short one,short two){
	return SLM_write((uchar)'M',one,two);
	}

SLM_error SLM_reset(void){
	return SLM_write((uchar)'R');
	}

// this is needed everytime a 'S' command is issued (don't know why....)  matt 2000
// must not use SLM_write as it is called by issue_cmd
void SLM_send_dummy(void){
	// Output a dummy cmd to insure processing of the previous cmd.
	SLM_write_slm_parport(SLM_REG1_SEL,0);
	SLM_write_slm_parport(SLM_REG0_SEL,0);
	}

// matt 2000 there should be some timing function here
// it should call SLM_wait_on_parport
// rather than having it called in SLM_write.
// check the functionality of both, I would be happier if it were here matt

//OUT
// SLM_write_slm_parport
SLM_error SLM_write_slm_parport(uchar reg, uchar data) {
	//cout<<"reg "<<(int)reg<<" data "<<(int)data<<endl;
	outb(reg,LPT_CTRL);
//	cout<<"("<<(int)reg<<",";
	outb(data,LPT_DATA);
//	cout<<(int)data<<")";
	outb(reg|1,LPT_CTRL);
	outb(reg,LPT_CTRL);
	return SLM_OK;
	}


// SLM_wait_on_parport
SLM_error SLM_wait_on_parport( void){
long	i=0;
	while(SLM_BUSY())
		if(i++ >= SLM_NO_TRIES){
			return SLM_TIMEOUT;
			}
	return SLM_OK;
	}

// There are two types of command, simple and complex.
// The simple command requires a count of the params
// The complex version requires the 'count' to be set to another value
// the steps are the same,
// a) write the 'cnt' to reg1
// b) write the params to reg2-7  params are single (two byte) shorts OR two bytes
// c) write the 'cmd' to reg0
// d) if the command is 'S' issue a dummy command
// I have provided functions and wrappers for various combinations of this
// including SLM_write(cmd,cnt,param0....param2) and SLM_write(cmd,cnt,byte0 .... byte5);
// and the 'simple' versions
// including SLM_write(cmd,param0....param2) and SLM_write(cmd,byte0 .... byte5);

// FIRST SIMPLE function wrappers for the complex functions
SLM_error SLM_write(uchar cmd){
	return SLM_write(cmd,0);
	}

SLM_error SLM_write(uchar cmd, uchar data1, uchar data2){
	return SLM_write(cmd,(uchar)1,data1,data2);
	}

SLM_error SLM_write(uchar cmd, uchar data1, uchar data2, uchar data3, uchar data4){
	return SLM_write(cmd,(uchar)2,data1,data2,data3,data4);
	}

SLM_error SLM_write(uchar cmd, uchar data1, uchar data2, uchar data3, uchar data4, uchar data5, uchar data6){
	return SLM_write(cmd,(uchar)3,data1,data2,data3,data4,data5,data6);
	}


SLM_error SLM_write(uchar cmd, short data1){
	return SLM_write(cmd,(uchar)1,data1);
	}

SLM_error SLM_write(uchar cmd,short data1, short data2){
	return SLM_write(cmd,(uchar)2,data1,data2);
	}

SLM_error SLM_write(uchar cmd,short data1, short data2, short data3){
	return SLM_write(cmd,(uchar)3,data1,data2,data3);
	}

SLM_error SLM_issue_cmd(uchar cmd){
char	status;
        SLM_write_slm_parport(SLM_REG0_SEL, cmd);  
	SLM_wait_on_parport();
	if(cmd=='S'){
		SLM_wait_on_parport();
		SLM_send_dummy;
		}
	// command has been sent, check on its status
	return SLM_OK;
	//return SLM_get_status();
	}

// Now the complex function
SLM_error SLM_write(uchar cmd, uchar cnt){
// check the order of the writes here, in case it is significant
	if(SLM_wait_on_parport()==SLM_TIMEOUT) return SLM_TIMEOUT;
	SLM_write_slm_parport(SLM_REG1_SEL, cnt);	
	SLM_issue_cmd(cmd);	
	return SLM_OK;
	}

SLM_error SLM_write(uchar cmd, uchar cnt,uchar data1, uchar data2){
// check the order of the writes here, in case it is significant
	if(SLM_wait_on_parport()==SLM_TIMEOUT) return SLM_TIMEOUT;
	SLM_write_slm_parport(SLM_REG1_SEL, cnt);	
	SLM_write_slm_parport(SLM_REG2_SEL, data1);
	SLM_write_slm_parport(SLM_REG3_SEL, data2);
	SLM_issue_cmd(cmd);	
	return SLM_OK;
	}

SLM_error SLM_write(uchar cmd, uchar cnt, uchar data1, uchar data2, uchar data3, uchar data4){
// check the order of the writes here, in case it is significant
	if(SLM_wait_on_parport()==SLM_TIMEOUT) return SLM_TIMEOUT;
	SLM_write_slm_parport(SLM_REG1_SEL, cnt);	
	SLM_write_slm_parport(SLM_REG2_SEL, data1);
	SLM_write_slm_parport(SLM_REG3_SEL, data2);
	SLM_write_slm_parport(SLM_REG4_SEL, data3);
	SLM_write_slm_parport(SLM_REG5_SEL, data4);
	SLM_issue_cmd(cmd);	
	return SLM_OK;
	}

SLM_error SLM_write(uchar cmd, uchar cnt, uchar data1, uchar data2, uchar data3, uchar data4, uchar data5, uchar data6){
// check the order of the writes here, in case it is significant
	if(SLM_wait_on_parport()==SLM_TIMEOUT) return SLM_TIMEOUT;
	SLM_write_slm_parport(SLM_REG1_SEL, cnt);	
	SLM_write_slm_parport(SLM_REG2_SEL, data1);
	SLM_write_slm_parport(SLM_REG3_SEL, data2);
	SLM_write_slm_parport(SLM_REG4_SEL, data3);
	SLM_write_slm_parport(SLM_REG5_SEL, data4);
	SLM_write_slm_parport(SLM_REG6_SEL, data5);
	SLM_write_slm_parport(SLM_REG7_SEL, data6);
	SLM_issue_cmd(cmd);	
	return SLM_OK;
	}


SLM_error SLM_write(uchar cmd,uchar cnt, short data1){
	if(SLM_wait_on_parport()==SLM_TIMEOUT) return SLM_TIMEOUT;
	SLM_write_slm_parport(SLM_REG1_SEL, cnt);	
	SLM_write_slm_parport(SLM_REG2_SEL, (uchar)(data1 >> 8));
	SLM_write_slm_parport(SLM_REG3_SEL, (uchar)(data1 & 0x00FF));
	SLM_issue_cmd(cmd);	
	return SLM_OK;
	}

SLM_error SLM_write(uchar cmd,uchar cnt,  short data1, short data2){
	if(SLM_wait_on_parport()==SLM_TIMEOUT) return SLM_TIMEOUT;
	SLM_write_slm_parport(SLM_REG1_SEL, cnt);	
	SLM_write_slm_parport(SLM_REG4_SEL, (uchar)(data2 >> 8));
	SLM_write_slm_parport(SLM_REG5_SEL, (uchar)(data2 & 0x00FF));
	SLM_write_slm_parport(SLM_REG2_SEL, (uchar)(data1 >> 8));
	SLM_write_slm_parport(SLM_REG3_SEL, (uchar)(data1 & 0x00FF));
	SLM_issue_cmd(cmd);	
	return SLM_OK;
	}

SLM_error SLM_write(uchar cmd, uchar cnt, short data1, short data2, short data3){
	if(SLM_wait_on_parport()==SLM_TIMEOUT) return SLM_TIMEOUT;
	SLM_write_slm_parport(SLM_REG1_SEL, cnt);	
	SLM_write_slm_parport(SLM_REG6_SEL, (uchar)(data3 >> 8));
	SLM_write_slm_parport(SLM_REG7_SEL, (uchar)(data3 & 0x00FF));
	SLM_write_slm_parport(SLM_REG4_SEL, (uchar)(data2 >> 8));
	SLM_write_slm_parport(SLM_REG5_SEL, (uchar)(data2 & 0x00FF));
	SLM_write_slm_parport(SLM_REG2_SEL, (uchar)(data1 >> 8));
	SLM_write_slm_parport(SLM_REG3_SEL, (uchar)(data1 & 0x00FF));
	SLM_issue_cmd(cmd);	
	return SLM_OK;
	}
